# Gitter Guidelines

Welcome, stranger. You probably just joined a Gitter channel for Deeplearning4j. There are a few things you should know that will help you use our deep-learning framework and engage our community.

1. The best place to start using DL4J is the [Quickstart page](https://deeplearning4j.org/docs/latest/deeplearning4j-quickstart). Please try to follow those instructions before you ask us install questions.
2. If you are new to deep learning or programming, you will want to check out [Deep Learning for Beginners](https://deeplearning4j.org/docs/latest/deeplearning4j-beginners)
3. We're doing our best to improve the documentation, but it's not perfect. We welcome ideas about how to improve it! Writing good docs is our responsibility; reading them is yours. Please consult the docs before you post in the channel. A little effort from you will earn a lot of respect from us. (DL4J is backed by a startup, Skymind, and we are serving customers as well as the open-source community, which feels like a lot sometimes.)
 * User guide: [https://deeplearning4j.org/docs/latest/](https://deeplearning4j.org/docs/latest/)
 * API: [https://deeplearning4j.org/api/latest/](https://deeplearning4j.org/api/latest/)
4. We welcome new contributors! Once you get familiar with the libs, if you see how our code can be improved, please file an issue or consider sending us a pull request with the new feature. [https://github.com/deeplearning4j/deeplearning4j/issues](https://github.com/deeplearning4j/deeplearning4j/issues)

Many of the questions asked on the Deeplearning4j Gitter support channel have been answered already in our documentation or can be easily Googled. To respect the Skymind team's time, Deeplearning4j users are kindly asked to remember a few things:

1. Please use Google before you ask a question. The Deeplearning4j Gitter channel should not be used as a human-enhanced search engine. (We promise that you'll end up with a better open-source framework if you only ask us the hard questions...) Please remember that DL4J Gitter channels are devoted to DL4J and other Skymind libraries specifically. We can't help with other frameworks or tools, which have their own docs and communities.
2. If you don't receive an immediate response, please post again and flag your question with the Gitter ID of one of the people in the channel answering questions. If you do receive a response and link, please spend some time reading and trying to understand the response and additional resources before you ask the same question again. 
3. To answer questions, we need to know about your OS, Java version, Maven version and we may even need to see your code and stacktrace. When we ask for code, please send us a gist using https://gist.github.com/. If you can't give us code, in many cases we can't help you. (It's also a great sign of commitment on your part!)
4. We're not perfect, and neither is our documentation. If you find ways for us to improve, please open an issue [here](https://github.com/deeplearning4j/deeplearning4j/issues) or email us at help@skymind.io and let us know what we need to fix. 
5. Neural nets aren't magic. They are inherently hard to tune. We get many questions from beginners on how to tune neural nets. If you must post a question related to tuning, please post to: https://gitter.im/deeplearning4j/deeplearning4j/tuninghelp

### Guidelines for Help with Neural Network Tuning:

In order to keep the main channel clear, please use [https://gitter.im/deeplearning4j/deeplearning4j/tuninghelp](https://gitter.im/deeplearning4j/deeplearning4j/tuninghelp) for any tuning related questions. Tuning questions are those like "what settings should I use for my net?" or "why am I getting poor performance from my network?".
 
Providing help for tuning neural networks can be quite time consuming for the development team, and takes away from other efforts (such as adding features, improving performance, improving documentation or fixing bugs). In order to keep the support load under control, please be aware of the following policy:

1. Before posting a question, please first read both [https://deeplearning4j.org/docs/latest/deeplearning4j-troubleshooting-training](https://deeplearning4j.org/docs/latest/deeplearning4j-troubleshooting-training) and [https://deeplearning4j.org/docs/latest/deeplearning4j-nn-visualization](https://deeplearning4j.org/docs/latest/deeplearning4j-nn-visualization). You may also find an answer to your question on one of the other pages: [https://deeplearning4j.org/docs/latest/](https://deeplearning4j.org/docs/latest/)
2. We generally won't answer questions that can be easily answered by searching Google or reading something like Andrej Karpathy's Stanford course on convolutional networks [http://cs231n.github.io/](http://cs231n.github.io/) or Ian Goodfellow and Yoshua Bengio's deep learning book [http://www.deeplearningbook.org/](http://www.deeplearningbook.org/)
3. For some questions/issues, it may not be possible to provide a short/simple answer to your question. In these cases, we might decide to answer your question by improving our documentation, instead of answering your question directly in Gitter. Please understand that improving our documentation helps *everyone* and is a better use of the team's time than answering one-off questions.
4. You should generally feel free to open issues ([https://github.com/deeplearning4j/deeplearning4j/issues](https://github.com/deeplearning4j/deeplearning4j/issues)) if you feel our documentation (troubleshooting/tuning) is lacking or doesn't answer common questions.
5. Upon entering the room, please do more than say "hi". Information-rich questions and comments are appreciated. Please keep the content relevant. Please note the below channels for different parts of the conversation.
 * Contributors/building from source: [https://gitter.im/deeplearning4j/deeplearning4j/earlyadopters](https://gitter.im/deeplearning4j/deeplearning4j/earlyadopters)

We follow the [Rust Code of Conduct](http://www.rust-lang.org/conduct.html).

We look forward to working with you, and if you are dedicated to building a deep learning solution with us, we will do our best to help you succeed. If you require commercial support for tuning your neural network models, please contact us via [http://www.skymind.io/contact/](http://www.skymind.io/contact/) or help@skymind.io
